/*
 *  NETREAD, {akii-root}/src/netread.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 *
 * 1997-1999 Varadi Laszlo (Vazul) <qgivazul@gold.uni-miskolc.hu>
 *                                  <varadi1@iit.uni-miskolc.hu>
 *                                     <vazul@mark.matav.net>
 *
 * Barminemu terjesztese es felhasznalasa a forraskodnak es a binaris
 * fajloknak, valamint azok reszeinek -- valtoztatasokkal vagy anelkul --
 * megengedett /:-)/, de ne feledd, hogy honann hoztad!
 *
 * EZ A PROGRAM VAZUL AGYSZULEMENYE (de sok otlet jott pl. Robitol), ES NEM
 * BIZTOS, HOGY STABILAN MUKODIK MINDENFELE KORULMENYEK KOZOTT! AZ ESETLEGES
 * HIBAKERT, GALIBAKERT FELELOSSEGET NEM VALLALOK, MINDENKI SAJAT MAZOHISTA
 * SZANDEKAIBOL HASZNALJA!
 * ==========================================================================
 *
 * Megjegyzes: OTLETEKET KEREK MEG! LEGYENEK JOL ATGONDOLTAK, HA LEHET!
 *
 * A friss verziokat itt keresd: <http://www.iit.uni-miskolc.hu/~varadi1/akp>
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 *                                             <ftp://vim.iit.uni-miskolc.hu>
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include "netread.h"
#include "main.h"
#include "debug.h"
#include "timers.h"

char netbuff[1024] = "";
int netbufflen = 0;
int pendinglines = 0;

#define BUFFERLEN 20000
char buffer[BUFFERLEN] = "";

int sock;
time_t lastact;
int sentbyte = 0, recvbyte = 0;

struct hostent *hostp;

int netconnect(char *server, int port, char **host)
{
    struct sockaddr_in arena;

    sock = socket(AF_INET, SOCK_STREAM, 0);
    if (sock < 0)
	return (-1);
    arena.sin_family = AF_INET;
    hostp = gethostbyname(server);
    if (!hostp) {
	if (h_errno > 0)
	    errno = h_errno;
	return (-1);
    }
    strcpy(*host, hostp->h_name);
    memcpy(&arena.sin_addr, hostp->h_addr, hostp->h_length);
    arena.sin_port = htons(port);
    if (connect(sock, (struct sockaddr *) &arena, sizeof(arena)) < 0)
	return (-1);
    recvbyte = sentbyte = 0;
    fcntl(sock, F_SETFL, O_NONBLOCK);
    pendinglines = 0;
    return (sock);
}
void netclose(void)
{
    if (sock > 0)
	close(sock);
    return;
}
int netread(void)
{
    int i, l, x;

    l = strlen(buffer);
    if (!pendinglines) {
	i = read(sock, buffer + l, BUFFERLEN - l - 1);
	if (!i) {
	    netclose();
	    return (-2);
	}
    }
    else {
	i = 0;
    }
    if (i < 0) {
	if (errno != EAGAIN) {
	    netclose();
	    return (-2);
	}
	errno = 0;
	i = 0;
    }
    l += i;
    buffer[l] = 0;
    for (x = 0; x < l; x++) {
	if ((buffer[x] != '\n') && (buffer[x] != '\t')) {
	    if ((buffer[x]>0) && (buffer[x] < 32))
		buffer[x] = 32;
	}
	if (buffer[x] == '\n') {
	    if (x < (l - 1)) {
		pendinglines = 1;
	    }
	    else
		pendinglines = 0;
	    buffer[x] = 0;
	    strcpy(netbuff, buffer);
	    netbufflen = x;
	    if (pendinglines) {
		for (x++, i = 0; x <= l; x++, i++) {
		    buffer[i] = buffer[x];
		}
	    }
	    else {
		buffer[0] = 0;
	    }
	    return (netbufflen);
	}
    }
    pendinglines = 0;
    return (0);
}
int netwrite(char *str)
{
    int i;
    long lastsendtime;

    if (!*str)
	return (0);
    if (*str == '\n')
	return (0);
    if (strchr(str, '\n')) {
	lastsendtime = stopstopper(&sendtimer);
	if (floodprotect && (lastsendtime < floodprotect)) {
	    delay(floodprotect - lastsendtime);
	}
	lastact2 = time(NULL);
	i = write(sock, str, strlen(str));
	startstopper(&sendtimer);
	return (i);
    }
    lastact2 = time(NULL);
    i = write(sock, str, strlen(str));
    return (i);
}
